<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [bullmq](./bullmq.md) &gt; [Queue3](./bullmq.queue3.md)

## Queue3 class

> Warning: This API is now obsolete.
> 
> Use Queue class instead [https://docs.bullmq.io/guide/queues](https://docs.bullmq.io/guide/queues)
> 

<b>Signature:</b>

```typescript
export declare class Queue3<T = any> extends EventEmitter 
```
<b>Extends:</b> EventEmitter

## Constructors

|  Constructor | Modifiers | Description |
|  --- | --- | --- |
|  [(constructor)(name, opts)](./bullmq.queue3._constructor_.md) |  | This is the Queue constructor. It creates a new Queue that is persisted in Redis. Every time the same queue is instantiated it tries to process all the old jobs that may exist from a previous unfinished session. |

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [name](./bullmq.queue3.name.md) |  | string | The name of the queue |
|  [queueEvents](./bullmq.queue3.queueevents.md) |  | [QueueEvents](./bullmq.queueevents.md) |  |

## Methods

|  Method | Modifiers | Description |
|  --- | --- | --- |
|  [add(jobName, data, opts)](./bullmq.queue3.add.md) |  |  |
|  [base64Name()](./bullmq.queue3.base64name.md) |  | Returns Queue name in base64 encoded format |
|  [clean(grace, limit, type)](./bullmq.queue3.clean.md) |  | Tells the queue remove all jobs created outside of a grace period in milliseconds. You can clean the jobs with the following states: completed, wait (typo for waiting), active, delayed, and failed. |
|  [clientName()](./bullmq.queue3.clientname.md) |  | Returns Queue name with keyPrefix (default: 'bull') |
|  [close()](./bullmq.queue3.close.md) |  | Closes the underlying redis client. Use this to perform a graceful shutdown.<code>close</code> can be called from anywhere, with one caveat: if called from within a job handler the queue won't close until after the job has been processed |
|  [count()](./bullmq.queue3.count.md) |  | Returns a promise that returns the number of jobs in the queue, waiting or paused. Since there may be other processes adding or processing jobs, this value may be true only for a very small amount of time. |
|  [detachListener(event, listener)](./bullmq.queue3.detachlistener.md) |  |  |
|  [empty()](./bullmq.queue3.empty.md) |  | Empties a queue deleting all the input lists and associated jobs. |
|  [getActive(start, end)](./bullmq.queue3.getactive.md) |  | Returns a promise that will return an array with the active jobs between start and end. |
|  [getActiveCount()](./bullmq.queue3.getactivecount.md) |  | Returns a promise that resolves with the quantity of active jobs. |
|  [getCompleted(start, end)](./bullmq.queue3.getcompleted.md) |  | Returns a promise that will return an array with the completed jobs between start and end. |
|  [getCompletedCount()](./bullmq.queue3.getcompletedcount.md) |  | Returns a promise that resolves with the quantity of completed jobs. |
|  [getDelayed(start, end)](./bullmq.queue3.getdelayed.md) |  | Returns a promise that will return an array with the delayed jobs between start and end. |
|  [getDelayedCount()](./bullmq.queue3.getdelayedcount.md) |  | Returns a promise that resolves with the quantity of delayed jobs. |
|  [getFailed(start, end)](./bullmq.queue3.getfailed.md) |  | Returns a promise that will return an array with the failed jobs between start and end. |
|  [getFailedCount()](./bullmq.queue3.getfailedcount.md) |  | Returns a promise that resolves with the quantity of failed jobs. |
|  [getJob(jobId)](./bullmq.queue3.getjob.md) |  | Returns a promise that will return the job instance associated with the jobId parameter. If the specified job cannot be located, the promise callback parameter will be set to null. |
|  [getJobCountByTypes(types)](./bullmq.queue3.getjobcountbytypes.md) |  | Returns a promise that resolves with the job counts for the given queue of the given types. |
|  [getJobCounts(types)](./bullmq.queue3.getjobcounts.md) |  | Returns a promise that resolves with the job counts for the given queue. |
|  [getJobLogs(jobId, start, end)](./bullmq.queue3.getjoblogs.md) |  | Returns a object with the logs according to the start and end arguments. The returned count value is the total amount of logs, useful for implementing pagination. |
|  [getJobs(types, start, end, asc)](./bullmq.queue3.getjobs.md) |  | Returns a promise that will return an array of job instances of the given types. Optional parameters for range and ordering are provided. |
|  [getNextJob()](./bullmq.queue3.getnextjob.md) |  |  |
|  [getPausedCount()](./bullmq.queue3.getpausedcount.md) |  | Returns a promise that resolves with the quantity of paused jobs. |
|  [getRepeatableCount()](./bullmq.queue3.getrepeatablecount.md) |  | Returns a promise that resolves to the quantity of repeatable jobs. |
|  [getRepeatableJobs(start, end, asc)](./bullmq.queue3.getrepeatablejobs.md) |  | Returns JobInformation of repeatable jobs (ordered descending). Provide a start and/or an end index to limit the number of results. Start defaults to 0, end to -1 and asc to false. |
|  [getWaiting(start, end)](./bullmq.queue3.getwaiting.md) |  | Returns a promise that will return an array with the waiting jobs between start and end. |
|  [getWaitingCount()](./bullmq.queue3.getwaitingcount.md) |  | Returns a promise that resolves with the quantity of waiting jobs. |
|  [getWorkers()](./bullmq.queue3.getworkers.md) |  | Returns Redis clients array which belongs to current Queue |
|  [isReady()](./bullmq.queue3.isready.md) |  | Returns a promise that resolves when Redis is connected and the queue is ready to accept jobs. This replaces the <code>ready</code> event emitted on Queue in previous versions. |
|  [isWorkerPaused()](./bullmq.queue3.isworkerpaused.md) |  |  |
|  [nextRepeatableJob(name, data, opts, skipCheckExists)](./bullmq.queue3.nextrepeatablejob.md) |  | ??? |
|  [off(event, listener)](./bullmq.queue3.off.md) |  |  |
|  [on(event, callback)](./bullmq.queue3.on.md) |  | Listens to queue events |
|  [on(event, callback)](./bullmq.queue3.on_9.md) |  | The queue has been resumed |
|  [on(event, callback)](./bullmq.queue3.on_10.md) |  | A job successfully removed. |
|  [on(event, callback)](./bullmq.queue3.on_11.md) |  | Old jobs have been cleaned from the queue. <code>jobs</code> is an array of jobs that were removed, and <code>type</code> is the type of those jobs. |
|  [on(event, callback)](./bullmq.queue3.on_12.md) |  | Emitted every time the queue has processed all the waiting jobs (even if there can be some delayed jobs not yet processed) |
|  [on(event, callback)](./bullmq.queue3.on_1.md) |  | An error occurred |
|  [on(event, callback)](./bullmq.queue3.on_2.md) |  | A Job is waiting to be processed as soon as a worker is idling. |
|  [on(event, callback)](./bullmq.queue3.on_3.md) |  | A job has started. You can use <code>jobPromise.cancel()</code> to abort it |
|  [on(event, callback)](./bullmq.queue3.on_4.md) |  | A job has been marked as stalled. This is useful for debugging job workers that crash or pause the event loop. |
|  [on(event, callback)](./bullmq.queue3.on_5.md) |  | A job's progress was updated |
|  [on(event, callback)](./bullmq.queue3.on_6.md) |  | A job successfully completed with a <code>result</code> |
|  [on(event, callback)](./bullmq.queue3.on_7.md) |  | A job failed with <code>err</code> as the reason |
|  [on(event, callback)](./bullmq.queue3.on_8.md) |  | The queue has been paused |
|  [once(event, listener)](./bullmq.queue3.once.md) |  |  |
|  [parseClientList(list)](./bullmq.queue3.parseclientlist.md) |  | Returns Redis clients array which belongs to current Queue from string with all redis clients |
|  [pause()](./bullmq.queue3.pause.md) |  | Returns a promise that resolves when the queue is paused.<!-- -->A paused queue will not process new jobs until resumed, but current jobs being processed will continue until they are finalized. The pause can be either global or local. If global, all workers in all queue instances for a given queue will be paused. If local, just this worker will stop processing new jobs after the current lock expires. This can be useful to stop a worker from taking new jobs prior to shutting down.<!-- -->Pausing a queue that is already paused does nothing. |
|  [pauseWorker(doNotWaitActive)](./bullmq.queue3.pauseworker.md) |  |  |
|  [process(processor)](./bullmq.queue3.process.md) |  | Defines a processing function for the jobs placed into a given Queue.<!-- -->The callback is called every time a job is placed in the queue. It is passed an instance of the job as first argument.<!-- -->If the callback signature contains the second optional done argument, the callback will be passed a done callback to be called after the job has been completed. The done callback can be called with an Error instance, to signal that the job did not complete successfully, or with a result as second argument (e.g.: done(null, result);) when the job is successful. Errors will be passed as a second argument to the "failed" event; results, as a second argument to the "completed" event.<!-- -->If, however, the callback signature does not contain the done argument, a promise must be returned to signal job completion. If the promise is rejected, the error will be passed as a second argument to the "failed" event. If it is resolved, its value will be the "completed" event's second argument. |
|  [removeAllListeners(event)](./bullmq.queue3.removealllisteners.md) |  |  |
|  [removeListener(event, listener)](./bullmq.queue3.removelistener.md) |  |  |
|  [removeRepeatable(name, opts)](./bullmq.queue3.removerepeatable.md) |  | Removes a given repeatable job. The RepeatOptions and JobId needs to be the same as the ones used for the job when it was added.<!-- -->name: The name of the to be removed job |
|  [removeRepeatableByKey(repeatJobKey)](./bullmq.queue3.removerepeatablebykey.md) |  | Removes a given repeatable job by key. |
|  [resume()](./bullmq.queue3.resume.md) |  | Returns a promise that resolves when the queue is resumed after being paused.<!-- -->The resume can be either local or global. If global, all workers in all queue instances for a given queue will be resumed. If local, only this worker will be resumed. Note that resuming a queue globally will not resume workers that have been paused locally; for those, resume(true) must be called directly on their instances.<!-- -->Resuming a queue that is not paused does nothing. |
|  [resumeWorker()](./bullmq.queue3.resumeworker.md) |  |  |
|  [retryJob(job)](./bullmq.queue3.retryjob.md) |  |  |
|  [setWorkerName()](./bullmq.queue3.setworkername.md) |  | Set clientName to Redis.client |

